#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

#include "aic94xx_seq_microcode.c"
#include "aic94xx_seq.h"

int main(int argv, char *argc[])
{
	struct sequencer_file_header *header;
	u8 buf[65535], *cseq_code, *lseq_code, *code_end, *tmp;
	u16 *cseq_vecs, *lseq_vecs;
	int fd;

	header = (struct sequencer_file_header *)&buf[0];
	cseq_vecs = (u16 *)&buf[sizeof(*header)];
	lseq_vecs = &cseq_vecs[CSEQ_NUM_VECS];
	cseq_code = (u8 *)&lseq_vecs[LSEQ_NUM_VECS];
	lseq_code = &cseq_code[sizeof(Cseq)];
	code_end = &lseq_code[sizeof(Lseq)];
	memset(header, 0, sizeof(*header));
	header->major = 1;
	header->minor = 1;
	strcpy(header->version, SAS_RAZOR_SEQUENCER_VERSION);
	header->cseq_table_offset = (u8 *)cseq_vecs - buf;
	header->cseq_table_size = CSEQ_NUM_VECS;
	header->lseq_table_offset = (u8 *)lseq_vecs - buf;
	header->lseq_table_size = LSEQ_NUM_VECS;
	header->cseq_code_offset = cseq_code - buf;
	header->cseq_code_size = lseq_code - cseq_code;
	header->lseq_code_offset = lseq_code - buf;
	header->lseq_code_size = code_end - lseq_code;
	header->mode2_task = MODE2_TASK;
	header->cseq_idle_loop = CSEQ_IDLE_LOOP_ENTRY;
	header->lseq_idle_loop = LSEQ_IDLE_LOOP_ENTRY;

	cseq_vecs[0] = CSEQ_INT_VEC0;
	cseq_vecs[1] = CSEQ_INT_VEC1;
	cseq_vecs[2] = CSEQ_INT_VEC2;

	lseq_vecs[0] = LSEQ_INT_VEC0;
	lseq_vecs[1] = LSEQ_INT_VEC1;
	lseq_vecs[2] = LSEQ_INT_VEC2;
	lseq_vecs[3] = LSEQ_INT_VEC3;
	lseq_vecs[4] = LSEQ_INT_VEC4;
	lseq_vecs[5] = LSEQ_INT_VEC5;
	lseq_vecs[6] = LSEQ_INT_VEC6;
	lseq_vecs[7] = LSEQ_INT_VEC7;
	lseq_vecs[8] = LSEQ_INT_VEC8;
	lseq_vecs[9] = LSEQ_INT_VEC9;
	lseq_vecs[10] = LSEQ_INT_VEC10;

	memcpy(cseq_code, &Cseq[0], sizeof(Cseq));
	memcpy(lseq_code, &Lseq[0], sizeof(Lseq));


	for(tmp = (u8 *)&header->major; tmp < code_end; tmp++)
		header->csum += *tmp;

	fd = open(SAS_RAZOR_SEQUENCER_FW_FILE, O_RDWR|O_CREAT);
	if (fd < 0) {
		perror("opening " SAS_RAZOR_SEQUENCER_FW_FILE);
		exit(1);
	}

	for(tmp = buf; tmp < code_end; tmp++)
		write(fd, tmp, 1);

	close(fd);


	return 0;
}
